--- JoglPipelineOLD.java	2016-11-07 16:27:54.000000000 +0100
+++ JoglPipeline.java	2017-12-28 22:54:49.000000000 +0100
@@ -26,23 +26,19 @@
 
 package javax.media.j3d;
 
-import java.awt.BorderLayout;
-import java.awt.Canvas;
-import java.awt.DisplayMode;
-import java.awt.EventQueue;
-import java.awt.Frame;
-import java.awt.GraphicsConfigTemplate;
-import java.awt.GraphicsConfiguration;
-import java.awt.GraphicsDevice;
-import java.awt.GraphicsEnvironment;
+import com.jogamp.common.nio.Buffers;
+import com.jogamp.nativewindow.*;
+import com.jogamp.nativewindow.awt.AWTGraphicsConfiguration;
+import com.jogamp.nativewindow.awt.AWTGraphicsDevice;
+import com.jogamp.nativewindow.awt.AWTGraphicsScreen;
+import com.jogamp.nativewindow.awt.JAWTWindow;
+import com.jogamp.opengl.*;
+
+import java.awt.*;
 import java.io.UnsupportedEncodingException;
 import java.lang.reflect.Field;
 import java.lang.reflect.Method;
-import java.nio.Buffer;
-import java.nio.ByteBuffer;
-import java.nio.DoubleBuffer;
-import java.nio.FloatBuffer;
-import java.nio.IntBuffer;
+import java.nio.*;
 import java.security.AccessController;
 import java.security.PrivilegedAction;
 import java.util.ArrayList;
@@ -52,35 +48,6 @@
 import java.util.regex.Matcher;
 import java.util.regex.Pattern;
 
-import com.jogamp.common.nio.Buffers;
-import com.jogamp.nativewindow.AbstractGraphicsDevice;
-import com.jogamp.nativewindow.AbstractGraphicsScreen;
-import com.jogamp.nativewindow.CapabilitiesChooser;
-import com.jogamp.nativewindow.GraphicsConfigurationFactory;
-import com.jogamp.nativewindow.NativeSurface;
-import com.jogamp.nativewindow.NativeWindowFactory;
-import com.jogamp.nativewindow.ProxySurface;
-import com.jogamp.nativewindow.UpstreamSurfaceHook;
-import com.jogamp.nativewindow.VisualIDHolder;
-import com.jogamp.nativewindow.awt.AWTGraphicsConfiguration;
-import com.jogamp.nativewindow.awt.AWTGraphicsDevice;
-import com.jogamp.nativewindow.awt.AWTGraphicsScreen;
-import com.jogamp.nativewindow.awt.JAWTWindow;
-import com.jogamp.opengl.DefaultGLCapabilitiesChooser;
-import com.jogamp.opengl.FBObject;
-import com.jogamp.opengl.GL;
-import com.jogamp.opengl.GL2;
-import com.jogamp.opengl.GLCapabilities;
-import com.jogamp.opengl.GLCapabilitiesChooser;
-import com.jogamp.opengl.GLCapabilitiesImmutable;
-import com.jogamp.opengl.GLContext;
-import com.jogamp.opengl.GLDrawable;
-import com.jogamp.opengl.GLDrawableFactory;
-import com.jogamp.opengl.GLException;
-import com.jogamp.opengl.GLFBODrawable;
-import com.jogamp.opengl.GLProfile;
-import com.jogamp.opengl.Threading;
-
 /**
  * Concrete implementation of Pipeline class for the JOGL rendering
  * pipeline.
@@ -98,10 +65,297 @@
     private static final int WAIT_TIME = 1000;
     // Configurable constant just in case we want to change this later
     private static final int MIN_FRAME_SIZE = 1;
+    private static final float[] black = new float[4];
+    private static final int screen_door[][] = {
+            /* 0 / 16 */
+            {
+                    0x00000000, 0x00000000, 0x00000000, 0x00000000,
+                    0x00000000, 0x00000000, 0x00000000, 0x00000000,
+                    0x00000000, 0x00000000, 0x00000000, 0x00000000,
+                    0x00000000, 0x00000000, 0x00000000, 0x00000000,
+                    0x00000000, 0x00000000, 0x00000000, 0x00000000,
+                    0x00000000, 0x00000000, 0x00000000, 0x00000000,
+                    0x00000000, 0x00000000, 0x00000000, 0x00000000,
+                    0x00000000, 0x00000000, 0x00000000, 0x00000000,
+            },
+            /* 1 / 16 */
+            {
+                    0x00000000, 0x22222222, 0x00000000, 0x00000000,
+                    0x00000000, 0x22222222, 0x00000000, 0x00000000,
+                    0x00000000, 0x22222222, 0x00000000, 0x00000000,
+                    0x00000000, 0x22222222, 0x00000000, 0x00000000,
+                    0x00000000, 0x22222222, 0x00000000, 0x00000000,
+                    0x00000000, 0x22222222, 0x00000000, 0x00000000,
+                    0x00000000, 0x22222222, 0x00000000, 0x00000000,
+                    0x00000000, 0x22222222, 0x00000000, 0x00000000,
+            },
+            /* 2 / 16 */
+            {
+                    0x00000000, 0x22222222, 0x00000000, 0x88888888,
+                    0x00000000, 0x22222222, 0x00000000, 0x88888888,
+                    0x00000000, 0x22222222, 0x00000000, 0x88888888,
+                    0x00000000, 0x22222222, 0x00000000, 0x88888888,
+                    0x00000000, 0x22222222, 0x00000000, 0x88888888,
+                    0x00000000, 0x22222222, 0x00000000, 0x88888888,
+                    0x00000000, 0x22222222, 0x00000000, 0x88888888,
+                    0x00000000, 0x22222222, 0x00000000, 0x88888888,
+            },
+            /* 3 / 16 */
+            {
+                    0x00000000, 0xaaaaaaaa, 0x00000000, 0x88888888,
+                    0x00000000, 0xaaaaaaaa, 0x00000000, 0x88888888,
+                    0x00000000, 0xaaaaaaaa, 0x00000000, 0x88888888,
+                    0x00000000, 0xaaaaaaaa, 0x00000000, 0x88888888,
+                    0x00000000, 0xaaaaaaaa, 0x00000000, 0x88888888,
+                    0x00000000, 0xaaaaaaaa, 0x00000000, 0x88888888,
+                    0x00000000, 0xaaaaaaaa, 0x00000000, 0x88888888,
+                    0x00000000, 0xaaaaaaaa, 0x00000000, 0x88888888,
+            },
+            /* 4 / 16 */
+            {
+                    0x00000000, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
+                    0x00000000, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
+                    0x00000000, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
+                    0x00000000, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
+                    0x00000000, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
+                    0x00000000, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
+                    0x00000000, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
+                    0x00000000, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
+            },
+            /* 5 / 16 */
+            {
+                    0x11111111, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
+                    0x11111111, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
+                    0x11111111, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
+                    0x11111111, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
+                    0x11111111, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
+                    0x11111111, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
+                    0x11111111, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
+                    0x11111111, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
+            },
+            /* 6 / 16 */
+            {
+                    0x11111111, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
+                    0x11111111, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
+                    0x11111111, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
+                    0x11111111, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
+                    0x11111111, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
+                    0x11111111, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
+                    0x11111111, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
+                    0x11111111, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
+            },
+            /* 7 / 16 */
+            {
+                    0x55555555, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
+                    0x55555555, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
+                    0x55555555, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
+                    0x55555555, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
+                    0x55555555, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
+                    0x55555555, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
+                    0x55555555, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
+                    0x55555555, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
+            },
+            /* 8 / 16 */
+            {
+                    0x55555555, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
+                    0x55555555, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
+                    0x55555555, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
+                    0x55555555, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
+                    0x55555555, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
+                    0x55555555, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
+                    0x55555555, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
+                    0x55555555, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
+            },
+            /* 9 / 16 */
+            {
+                    0x77777777, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
+                    0x77777777, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
+                    0x77777777, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
+                    0x77777777, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
+                    0x77777777, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
+                    0x77777777, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
+                    0x77777777, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
+                    0x77777777, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
+            },
+            /* 10 / 16 */
+            {
+                    0x77777777, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
+                    0x77777777, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
+                    0x77777777, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
+                    0x77777777, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
+                    0x77777777, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
+                    0x77777777, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
+                    0x77777777, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
+                    0x77777777, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
+            },
+            /* 11 / 16 */
+            {
+                    0xffffffff, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
+                    0xffffffff, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
+                    0xffffffff, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
+                    0xffffffff, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
+                    0xffffffff, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
+                    0xffffffff, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
+                    0xffffffff, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
+                    0xffffffff, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
+            },
+            /* 12 / 16 */
+            {
+                    0xffffffff, 0xaaaaaaaa, 0xffffffff, 0xaaaaaaaa,
+                    0xffffffff, 0xaaaaaaaa, 0xffffffff, 0xaaaaaaaa,
+                    0xffffffff, 0xaaaaaaaa, 0xffffffff, 0xaaaaaaaa,
+                    0xffffffff, 0xaaaaaaaa, 0xffffffff, 0xaaaaaaaa,
+                    0xffffffff, 0xaaaaaaaa, 0xffffffff, 0xaaaaaaaa,
+                    0xffffffff, 0xaaaaaaaa, 0xffffffff, 0xaaaaaaaa,
+                    0xffffffff, 0xaaaaaaaa, 0xffffffff, 0xaaaaaaaa,
+                    0xffffffff, 0xaaaaaaaa, 0xffffffff, 0xaaaaaaaa,
+            },
+            /* 13 / 16 */
+            {
+                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xaaaaaaaa,
+                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xaaaaaaaa,
+                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xaaaaaaaa,
+                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xaaaaaaaa,
+                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xaaaaaaaa,
+                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xaaaaaaaa,
+                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xaaaaaaaa,
+                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xaaaaaaaa,
+            },
+            /* 14 / 16 */
+            {
+                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xeeeeeeee,
+                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xeeeeeeee,
+                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xeeeeeeee,
+                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xeeeeeeee,
+                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xeeeeeeee,
+                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xeeeeeeee,
+                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xeeeeeeee,
+                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xeeeeeeee,
+            },
+            /* 15 / 16 */
+            {
+                    0xffffffff, 0xffffffff, 0xffffffff, 0xeeeeeeee,
+                    0xffffffff, 0xffffffff, 0xffffffff, 0xeeeeeeee,
+                    0xffffffff, 0xffffffff, 0xffffffff, 0xeeeeeeee,
+                    0xffffffff, 0xffffffff, 0xffffffff, 0xeeeeeeee,
+                    0xffffffff, 0xffffffff, 0xffffffff, 0xeeeeeeee,
+                    0xffffffff, 0xffffffff, 0xffffffff, 0xeeeeeeee,
+                    0xffffffff, 0xffffffff, 0xffffffff, 0xeeeeeeee,
+                    0xffffffff, 0xffffffff, 0xffffffff, 0xeeeeeeee,
+            },
+            /* 16 / 16 */
+            {
+                    0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
+                    0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
+                    0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
+                    0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
+                    0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
+                    0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
+                    0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
+                    0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
+            },
+    };
+    private static final ByteBuffer[] screen_door_table = new ByteBuffer[screen_door.length];
+    private static final int[] blendFunctionTable = new int[TransparencyAttributes.MAX_BLEND_FUNC_TABLE_SIZE];
 
-    private GLProfile profile;
+    // ---------------------------------------------------------------------
+
+    //
+    // GeometryArrayRetained methods
+    //
+    // mapping from java enum to gl enum
+    private static final int[] _gl_combineRgbSrcIndex = {
+            GL2.GL_SOURCE0_RGB,
+            GL2.GL_SOURCE1_RGB,
+            GL2.GL_SOURCE2_RGB,
+    };
+    private static final int[] _gl_combineAlphaSrcIndex = {
+            GL2.GL_SOURCE0_ALPHA,
+            GL2.GL_SOURCE1_ALPHA,
+            GL2.GL_SOURCE2_ALPHA,
+    };
+    private static final int[] _gl_combineRgbOpIndex = {
+            GL2.GL_OPERAND0_RGB,
+            GL2.GL_OPERAND1_RGB,
+            GL2.GL_OPERAND2_RGB,
+    };
+    private static final int[] _gl_combineAlphaOpIndex = {
+            GL2.GL_OPERAND0_ALPHA,
+            GL2.GL_OPERAND1_ALPHA,
+            GL2.GL_OPERAND2_ALPHA,
+    };
+    private static final int[] _gl_combineSrc = {
+            GL2.GL_PRIMARY_COLOR,      // TextureAttributes.COMBINE_OBJECT_COLOR
+            GL.GL_TEXTURE,            // TextureAttributes.COMBINE_TEXTURE
+            GL2.GL_CONSTANT,           // TextureAttributes.COMBINE_CONSTANT_COLOR
+            GL2.GL_PREVIOUS,           // TextureAttributes.COMBINE_PREVIOUS_TEXTURE_UNIT_STATE
+    };
+    private static final int[] _gl_combineFcn = {
+            GL.GL_SRC_COLOR,              // TextureAttributes.COMBINE_SRC_COLOR
+            GL.GL_ONE_MINUS_SRC_COLOR,    // TextureAttributes.COMBINE_ONE_MINUS_SRC_COLOR
+            GL.GL_SRC_ALPHA,              // TextureAttributes.COMBINE_SRC_ALPHA
+            GL.GL_ONE_MINUS_SRC_ALPHA,    // TextureAttributes.COMBINE_ONE_MINUS_SRC_ALPHA
+    };
+    // mapping from java enum to gl enum
+    private static final int[] _gl_textureCubeMapFace = {
+            GL.GL_TEXTURE_CUBE_MAP_POSITIVE_X,
+            GL.GL_TEXTURE_CUBE_MAP_NEGATIVE_X,
+            GL.GL_TEXTURE_CUBE_MAP_POSITIVE_Y,
+            GL.GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,
+            GL.GL_TEXTURE_CUBE_MAP_POSITIVE_Z,
+            GL.GL_TEXTURE_CUBE_MAP_NEGATIVE_Z,
+    };
+
+    //----------------------------------------------------------------------
+    // Private helper methods for GeometryArrayRetained
+    //
+    private static ThreadLocal<FloatBuffer> nioVertexTemp = new ThreadLocal<FloatBuffer>();
+    private static ThreadLocal<DoubleBuffer> nioVertexDoubleTemp = new ThreadLocal<DoubleBuffer>();
+    private static ThreadLocal<FloatBuffer> nioColorTemp = new ThreadLocal<FloatBuffer>();
+    private static ThreadLocal<ByteBuffer> nioColorByteTemp = new ThreadLocal<ByteBuffer>();
+    private static ThreadLocal<FloatBuffer> nioNormalTemp = new ThreadLocal<FloatBuffer>();
+    private static ThreadLocal<FloatBuffer[]> nioTexCoordSetTemp = new ThreadLocal<FloatBuffer[]>();
+    private static ThreadLocal<FloatBuffer[]> nioVertexAttrSetTemp = new ThreadLocal<FloatBuffer[]>();
+
+    static {
+        int eachLen = screen_door[0].length * Buffers.SIZEOF_INT;
+        ByteBuffer buf = Buffers.newDirectByteBuffer(screen_door.length * eachLen);
+        IntBuffer intBuf = buf.asIntBuffer();
+        for (int i = 0; i < screen_door.length; i++) {
+            intBuf.put(screen_door[i]);
+        }
+        buf.rewind();
+        for (int i = 0; i < screen_door.length; i++) {
+            buf.position(i * eachLen);
+            buf.limit((i + 1) * eachLen);
+            screen_door_table[i] = buf.slice();
+        }
+    }
+
+    static {
+        blendFunctionTable[TransparencyAttributes.BLEND_ZERO] = GL.GL_ZERO;
+        blendFunctionTable[TransparencyAttributes.BLEND_ONE] = GL.GL_ONE;
+        blendFunctionTable[TransparencyAttributes.BLEND_SRC_ALPHA] = GL.GL_SRC_ALPHA;
+        blendFunctionTable[TransparencyAttributes.BLEND_ONE_MINUS_SRC_ALPHA] = GL.GL_ONE_MINUS_SRC_ALPHA;
+        blendFunctionTable[TransparencyAttributes.BLEND_DST_COLOR] = GL.GL_DST_COLOR;
+        blendFunctionTable[TransparencyAttributes.BLEND_ONE_MINUS_DST_COLOR] = GL.GL_ONE_MINUS_DST_COLOR;
+        blendFunctionTable[TransparencyAttributes.BLEND_SRC_COLOR] = GL.GL_SRC_COLOR;
+        blendFunctionTable[TransparencyAttributes.BLEND_ONE_MINUS_SRC_COLOR] = GL.GL_ONE_MINUS_SRC_COLOR;
+        blendFunctionTable[TransparencyAttributes.BLEND_CONSTANT_COLOR] = GL2.GL_CONSTANT_COLOR;
+    }
 
+    int numInvalidLists = 0;
+    private GLProfile profile;
     private Object mainThreadContext;    // Fix for Bug 983
+    private boolean checkedForGetScreenMethod = false;
+
+
+    // ---------------------------------------------------------------------
+
+    //
+    // IndexedGeometryArrayRetained methods
+    //
+    private Method getScreenMethod = null;
 
     /**
      * Constructor for singleton JoglPipeline instance
@@ -116,6 +370,250 @@
         }
     }
 
+    private static final String getFilterName(int filter) {
+        switch (filter) {
+            case Texture.FASTEST:
+                return "Texture.FASTEST";
+            case Texture.NICEST:
+                return "Texture.NICEST";
+            case Texture.BASE_LEVEL_POINT:
+                return "Texture.BASE_LEVEL_POINT";
+            case Texture.BASE_LEVEL_LINEAR:
+                return "Texture.BASE_LEVEL_LINEAR";
+            case Texture.MULTI_LEVEL_POINT:
+                return "Texture.MULTI_LEVEL_POINT";
+            case Texture.MULTI_LEVEL_LINEAR:
+                return "Texture.MULTI_LEVEL_LINEAR";
+            case Texture.FILTER4:
+                return "Texture.FILTER4";
+            case Texture.LINEAR_SHARPEN:
+                return "Texture.LINEAR_SHARPEN";
+            case Texture.LINEAR_SHARPEN_RGB:
+                return "Texture.LINEAR_SHARPEN_RGB";
+            case Texture.LINEAR_SHARPEN_ALPHA:
+                return "Texture.LINEAR_SHARPEN_ALPHA";
+            case Texture2D.LINEAR_DETAIL:
+                return "Texture.LINEAR_DETAIL";
+            case Texture2D.LINEAR_DETAIL_RGB:
+                return "Texture.LINEAR_DETAIL_RGB";
+            case Texture2D.LINEAR_DETAIL_ALPHA:
+                return "Texture.LINEAR_DETAIL_ALPHA";
+            default:
+                return "(unknown)";
+        }
+    }
+
+    static boolean isOffscreenLayerSurfaceEnabled(Canvas3D cv) {
+        if (cv.drawable == null || cv.offScreen)
+            return false;
+
+        JoglDrawable joglDrawble = (JoglDrawable) cv.drawable;
+        JAWTWindow jawtwindow = (JAWTWindow) joglDrawble.getNativeWindow();
+        if (jawtwindow == null)
+            return false;
+
+        return jawtwindow.isOffscreenLayerSurfaceEnabled();
+    }
+
+    static boolean hasFBObjectSizeChanged(JoglDrawable jdraw, int width, int height) {
+        if (!(jdraw.getGLDrawable() instanceof GLFBODrawable))
+            return false;
+
+        FBObject fboBack = ((GLFBODrawable) jdraw.getGLDrawable()).getFBObject(GL.GL_BACK);
+        if (fboBack == null)
+            return false;
+
+        return (width != fboBack.getWidth() || height != fboBack.getHeight());
+    }
+
+
+    //----------------------------------------------------------------------
+    //
+    // Helper routines for IndexedGeometryArrayRetained
+    //
+
+    private static AWTGraphicsConfiguration createAwtGraphicsConfiguration(GLCapabilities capabilities,
+                                                                           CapabilitiesChooser chooser,
+                                                                           AbstractGraphicsScreen screen) {
+        GraphicsConfigurationFactory factory = GraphicsConfigurationFactory.getFactory(AWTGraphicsDevice.class, GLCapabilities.class);
+        AWTGraphicsConfiguration awtGraphicsConfiguration = (AWTGraphicsConfiguration) factory.chooseGraphicsConfiguration(capabilities, capabilities,
+                chooser, screen, VisualIDHolder.VID_UNDEFINED);
+        return awtGraphicsConfiguration;
+    }
+
+    private static FloatBuffer getVertexArrayBuffer(float[] vertexArray) {
+        return getVertexArrayBuffer(vertexArray, true);
+    }
+
+
+    // ---------------------------------------------------------------------
+
+    //
+    // GraphicsContext3D methods
+    //
+
+    private static FloatBuffer getVertexArrayBuffer(float[] vertexArray, boolean copyData) {
+        return getNIOBuffer(vertexArray, nioVertexTemp, copyData);
+    }
+
+    // ---------------------------------------------------------------------
+
+    //
+    // GLSLShaderProgramRetained methods
+    //
+
+    // ShaderAttributeValue methods
+
+    private static DoubleBuffer getVertexArrayBuffer(double[] vertexArray) {
+        return getVertexArrayBuffer(vertexArray, true);
+    }
+
+    private static DoubleBuffer getVertexArrayBuffer(double[] vertexArray, boolean copyData) {
+        return getNIOBuffer(vertexArray, nioVertexDoubleTemp, true);
+    }
+
+    private static FloatBuffer getColorArrayBuffer(float[] colorArray) {
+        return getColorArrayBuffer(colorArray, true);
+    }
+
+    private static FloatBuffer getColorArrayBuffer(float[] colorArray, boolean copyData) {
+        return getNIOBuffer(colorArray, nioColorTemp, true);
+    }
+
+    private static ByteBuffer getColorArrayBuffer(byte[] colorArray) {
+        return getColorArrayBuffer(colorArray, true);
+    }
+
+    private static ByteBuffer getColorArrayBuffer(byte[] colorArray, boolean copyData) {
+        return getNIOBuffer(colorArray, nioColorByteTemp, true);
+    }
+
+    private static FloatBuffer getNormalArrayBuffer(float[] normalArray) {
+        return getNormalArrayBuffer(normalArray, true);
+    }
+
+    private static FloatBuffer getNormalArrayBuffer(float[] normalArray, boolean copyData) {
+        return getNIOBuffer(normalArray, nioNormalTemp, true);
+    }
+
+    private static FloatBuffer[] getTexCoordSetBuffer(Object[] texCoordSet) {
+        return getNIOBuffer(texCoordSet, nioTexCoordSetTemp);
+    }
+
+    private static FloatBuffer[] getVertexAttrSetBuffer(Object[] vertexAttrSet) {
+        return getNIOBuffer(vertexAttrSet, nioVertexAttrSetTemp);
+    }
+
+    // ShaderAttributeArray methods
+
+    private static FloatBuffer getNIOBuffer(float[] array, ThreadLocal<FloatBuffer> threadLocal, boolean copyData) {
+        if (array == null) {
+            return null;
+        }
+        FloatBuffer buf = threadLocal.get();
+        if (buf == null) {
+            buf = Buffers.newDirectFloatBuffer(array.length);
+            threadLocal.set(buf);
+        } else {
+            buf.rewind();
+            if (buf.remaining() < array.length) {
+                int newSize = Math.max(2 * buf.remaining(), array.length);
+                buf = Buffers.newDirectFloatBuffer(newSize);
+                threadLocal.set(buf);
+            }
+        }
+        if (copyData) {
+            buf.put(array);
+            buf.rewind();
+        }
+        return buf;
+    }
+
+    private static DoubleBuffer getNIOBuffer(double[] array, ThreadLocal<DoubleBuffer> threadLocal, boolean copyData) {
+        if (array == null) {
+            return null;
+        }
+        DoubleBuffer buf = threadLocal.get();
+        if (buf == null) {
+            buf = Buffers.newDirectDoubleBuffer(array.length);
+            threadLocal.set(buf);
+        } else {
+            buf.rewind();
+            if (buf.remaining() < array.length) {
+                int newSize = Math.max(2 * buf.remaining(), array.length);
+                buf = Buffers.newDirectDoubleBuffer(newSize);
+                threadLocal.set(buf);
+            }
+        }
+        if (copyData) {
+            buf.put(array);
+            buf.rewind();
+        }
+        return buf;
+    }
+
+    private static ByteBuffer getNIOBuffer(byte[] array, ThreadLocal<ByteBuffer> threadLocal, boolean copyData) {
+        if (array == null) {
+            return null;
+        }
+        ByteBuffer buf = threadLocal.get();
+        if (buf == null) {
+            buf = Buffers.newDirectByteBuffer(array.length);
+            threadLocal.set(buf);
+        } else {
+            buf.rewind();
+            if (buf.remaining() < array.length) {
+                int newSize = Math.max(2 * buf.remaining(), array.length);
+                buf = Buffers.newDirectByteBuffer(newSize);
+                threadLocal.set(buf);
+            }
+        }
+        if (copyData) {
+            buf.put(array);
+            buf.rewind();
+        }
+        return buf;
+    }
+
+    private static FloatBuffer[] getNIOBuffer(Object[] array, ThreadLocal<FloatBuffer[]> threadLocal) {
+        if (array == null) {
+            return null;
+        }
+        FloatBuffer[] bufs = threadLocal.get();
+
+        // First resize array of FloatBuffers
+        if (bufs == null) {
+            bufs = new FloatBuffer[array.length];
+            threadLocal.set(bufs);
+        } else if (bufs.length < array.length) {
+            FloatBuffer[] newBufs = new FloatBuffer[array.length];
+            System.arraycopy(bufs, 0, newBufs, 0, bufs.length);
+            bufs = newBufs;
+            threadLocal.set(bufs);
+        }
+
+        // Now go down array of arrays, converting each into a direct FloatBuffer
+        for (int i = 0; i < array.length; i++) {
+            float[] cur = (float[]) array[i];
+            FloatBuffer buf = bufs[i];
+            if (buf == null) {
+                buf = Buffers.newDirectFloatBuffer(cur.length);
+                bufs[i] = buf;
+            } else {
+                buf.rewind();
+                if (buf.remaining() < cur.length) {
+                    int newSize = Math.max(2 * buf.remaining(), cur.length);
+                    buf = Buffers.newDirectFloatBuffer(newSize);
+                    bufs[i] = buf;
+                }
+            }
+            buf.put(cur);
+            buf.rewind();
+        }
+
+        return bufs;
+    }
+
     /**
      * Initialize the pipeline
      */
@@ -132,26 +630,20 @@
         // TODO: finish this with any other needed initialization
     }
 
-    // ---------------------------------------------------------------------
-
-    //
-    // GeometryArrayRetained methods
-    //
-
     // used for GeometryArrays by Copy or interleaved
     @Override
     void execute(Context ctx,
-            GeometryArrayRetained geo, int geo_type,
-            boolean isNonUniformScale,
-            boolean useAlpha,
-            boolean ignoreVertexColors,
-            int startVIndex, int vcount, int vformat,
-            int texCoordSetCount, int[] texCoordSetMap,
-            int texCoordSetMapLen,
-            int[] texUnitOffset,
-            int numActiveTexUnitState,
-            int vertexAttrCount, int[] vertexAttrSizes,
-            float[] varray, float[] carray, int cDirty) {
+                 GeometryArrayRetained geo, int geo_type,
+                 boolean isNonUniformScale,
+                 boolean useAlpha,
+                 boolean ignoreVertexColors,
+                 int startVIndex, int vcount, int vformat,
+                 int texCoordSetCount, int[] texCoordSetMap,
+                 int texCoordSetMapLen,
+                 int[] texUnitOffset,
+                 int numActiveTexUnitState,
+                 int vertexAttrCount, int[] vertexAttrSizes,
+                 float[] varray, float[] carray, int cDirty) {
         if (VERBOSE) System.err.println("JoglPipeline.execute()");
 
         executeGeometryArray(ctx, geo, geo_type, isNonUniformScale, useAlpha,
